"""
###########################################
# BA_Conbagui_Gold Coin Tutorial Scripted #
###########################################

Needs scripts
layerfx bevel/emboss
text_along_path

Also requires 2 vectors and a brush include
in the package.
Put the brush into your brushes folder,
Put the 2 svg path files into a folder you
can easily browse to from the dialog.

file: CoinEdge.gbr < the brush
file: a_path.svg   < the paths to import into the script
file: b_path.svg   < through the dialog box.
...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# You should have received a copy of the GNU General Public License           #
# along with this program if not, you can view the GNU General Public         #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                                              #
###############################################################################
"""
#!/usr/bin/env python
from gimpfu import *
import os, string, sys
import decimal

def BA_Conbagui_Coin(inImage,inDrawable,vectordir,fg_1,fg_2,edg,font_t,fs_t,ex_t,text_t,font_b,fs_b,ex_b,text_b,bump,bh_1,bh_2,bh_3,ira,guides):
    inwidth = inImage.width
    inheight = inImage.height
    intype = inImage.base_type
    inname = inDrawable.name

    white='#ffffff'
    gray ='#ffffff'
    black='#000000'
    pat1 = 'Clipboard' ## fx_bevel: needs pattern but doesn't use it.  Everyone has the clipboard so no errors.

    if inwidth != 1600 or inheight !=1200:
        pdb.gimp_message('Background Image must be 1600 Width x 1200 Height')
        return()
    
    if '.' in inname:
        split = inname.split(".", 1)
        inname = split[0]
    suffix = ",BA_Conbagui's Coin Tutorial Script"

    pdb.gimp_context_push()

####### import the blackleather background - only because in the tutorial, 
####### but made script dependant on it for correct image size

    inlays = inImage.layers
    inimglay0 = inlays[0]
    image = pdb.gimp_image_new (inwidth, inheight, intype)
    #pdb.gimp_display_new(image)  #toggle off for speed and uncluttered display/on for troubleshooting#
    blackleather = pdb.gimp_layer_new_from_drawable(inimglay0,image) 
    blackleather.mode = NORMAL_MODE
    blackleather.name = 'blackleather'
    blackleather.opacity = 100.0 
    image.add_layer (blackleather, 0)
    pdb.gimp_item_set_visible(blackleather, False)  
    alpha=pdb.gimp_drawable_has_alpha(blackleather)
    if not alpha:
        pdb.gimp_layer_add_alpha(blackleather)    #  RGBA
    
####### make guides for user

    if guides: # creating guides, if chosen by user. Script has no use for them.
        hguide = pdb.gimp_image_add_hguide(image,inheight/2)
        vguide = pdb.gimp_image_add_vguide(image,inwidth/2)
        hguide = pdb.gimp_image_add_hguide(image,50)
        hguide = pdb.gimp_image_add_hguide(image,1150)
        vguide = pdb.gimp_image_add_vguide(image,395) 
        vguide = pdb.gimp_image_add_vguide(image,1205)


####### coin layer
    pdb.gimp_image_select_ellipse(image,0,(inwidth-1000)/2,(inheight-1000)/2, 1000, 1000)
    coinblank = image.new_layer()
    coinblank.name='coin blank'
    pdb.plug_in_sel2path(image, coinblank)
    coinvector = pdb.gimp_image_get_active_vectors(image)
    pdb.gimp_item_set_name(coinvector,'outer coin path')
    pdb.gimp_context_set_foreground(fg_1)
    pdb.gimp_edit_fill(coinblank, 0)
    coin = pdb.gimp_layer_new_from_visible(image,image,'Coin')
    image.add_layer(coin,0)
    pdb.gimp_item_set_visible(coinblank, False)
    pdb.gimp_item_set_visible(coin, False)
    

####### rim layer
    pdb.gimp_selection_shrink(image,7)
    pdb.plug_in_sel2path(image, coinblank) #drawable is unused, but needs to be there.
    edgevector = pdb.gimp_image_get_active_vectors(image)
    pdb.gimp_item_set_name(edgevector,'rim edge vector')
    pdb.gimp_selection_none(image)

    pdb.gimp_image_select_item(image,0,coin)    
    pdb.gimp_context_set_foreground(fg_2)
    rim = image.new_layer()
    rim.name = 'rim'
    pdb.gimp_edit_fill(rim, 0)
    pdb.gimp_selection_shrink(image, 25) #for a total of 25, less the 7 from the edge vector
    pdb.gimp_edit_cut(rim)
    pdb.gimp_selection_none(image)

####### fx bevel the rim of the coin edge

    pdb.python_layer_fx_bevel_emboss(image,rim,1,65,0,10,14,145,35,0,white,5,100.0,black,3,55.0,0,0,pat1,100,100,0,1)
    rim = pdb.gimp_image_get_active_layer(image) # layer_fx changes input layer id - get new id with same name.
    pdb.gimp_item_set_visible(rim, False)
    ############################################################################################
    # TOTAL FAILURE SROKING PATH WITH DIRECTION AND/OR DIRECTION DYNAMIC. GIMP BUG OR OMISSION #
    # WORK AROUND - stroked manually from UI, then made a .gbr Brush from the pattern.         #
    ############################################################################################

####### grooves layer

    grooves=image.new_layer()
    grooves.name = 'grooves'
    if edg:
        pdb.gimp_context_set_foreground(fg_2)
        pdb.gimp_context_set_brush('Coin Edge')
        pdb.gimp_context_set_brush_size(1600)
        pdb.gimp_paintbrush_default(grooves,2,(800,600))
        pdb.gimp_item_set_visible(grooves, False)

####### inner ring layer
    
    innerring=image.new_layer()
    innerring.name='Inner Ring'
    pdb.gimp_context_set_foreground(fg_1)
    pdb.gimp_context_set_brush('Ring Hardness 100')
    pdb.gimp_context_set_brush_size(700)
    pdb.gimp_paintbrush_default(innerring,2, (800,600))
    pdb.plug_in_gauss_rle2(image,innerring,5,5)
# duplicate 
    innerring2 = pdb.gimp_layer_new_from_visible(image,image,'Inner Ring Deep')
    image.add_layer(innerring2,0)
    #cut center out to 560x560 - middle looks deep if ring emboss is lowlook deep in the middle
    pdb.gimp_image_select_ellipse(image,0,520,320,560,560)
    pdb.gimp_edit_cut(innerring2)
    pdb.gimp_item_set_visible(innerring , False)
    pdb.gimp_item_set_visible(innerring2, False)

####### design layer

    design=image.new_layer()
    design.name = 'Design'
    pdb.gimp_image_select_ellipse(image,0,(inwidth-615)/2,(inheight-615)/2, 615, 615)
    pdb.plug_in_sel2path(image,None)
    designvector = pdb.gimp_image_get_active_vectors(image)
    pdb.gimp_item_set_name(designvector,'design path')
    pdb.gimp_selection_none(image)
    pdb.gimp_item_set_visible(design, False)

####### making the design

    pdb.gimp_context_set_foreground(fg_1)
    #pdb.gimp_context_set_brush('2. Star')      # brush '2. Star' is not editable so duplicate it
    Star = pdb.gimp_brush_duplicate('2. Star') # duplicate is generated, so it is editable and Autosaved so delete after use.
    pdb.gimp_context_set_brush(Star)           
    pdb.gimp_context_set_brush_size(60)
    #pdb.gimp_context_set_dynamics('Track Direction') #Track Direction dynamic INOP. No error, but stars are all positioned upright.
    pdb.gimp_brush_set_spacing(Star,295) 
    dv = pdb.gimp_image_get_active_vectors(image)
    pdb.gimp_edit_stroke_vectors(design, dv)
    pdb.gimp_brush_delete(Star) 
    pdb.plug_in_gauss_rle2(image,design,5,5)
  
####### legend layer

    pdb.gimp_image_set_active_layer(image,design)
    legend=image.new_layer()
    legend.name = 'Legend'
    pdb.gimp_item_set_visible(legend, False)   

####### import the UI created paths in svg file format

    vectorlist = ['b_path.svg','a_path.svg']
    for i in vectorlist:
        pdb.gimp_vectors_import_from_file(image,vectordir+"\\"+i,0,0)
    a_path = pdb.gimp_image_get_vectors_by_name(image,'a_path')
    b_path = pdb.gimp_image_get_vectors_by_name(image,'b_path')

####### running ofnuts text along path script 

    # pdb.python_fu_text_along_path_full(image, path, text, fontName, fontSize, layout, pivotY, useKerning, extraSpacing, and 6 more 0,0,0,0,0,0)
    pdb.python_fu_text_along_path_full(image,a_path,text_t,font_t,fs_t,2,5,1,ex_t,0,0,0,0,0,0)
    a_stroked = pdb.gimp_image_get_active_vectors(image)
    pdb.python_fu_text_along_path_full(image,b_path,text_b,font_b,fs_b,2,5,1,ex_b,0,0,0,0,0,0)
    b_stroked = pdb.gimp_image_get_active_vectors(image)
    pdb.gimp_selection_none(image)
    
####### set selections for fill and bump

   #pdb.gimp_vectors_to_selection(vectors, operation, antialias, feather, feather_radius_x, feather_radius_y)
    pdb.gimp_vectors_to_selection(a_stroked,0,1,0,0,0)
    pdb.gimp_vectors_to_selection(b_stroked,0,1,0,0,0)
    pdb.gimp_image_set_active_layer(image, legend)
    pdb.gimp_context_set_foreground(gray) #med-light gray for better bump.
    pdb.gimp_edit_fill(legend,0)
    pdb.gimp_selection_none(image)
    pdb.plug_in_gauss_rle2(image,legend,5,5) #medium blur for less alias on bump. 
    pdb.gimp_vectors_set_visible(a_stroked,0)
    pdb.gimp_vectors_set_visible(b_stroked,0)

####### leaving the map layers, if user wants to 'flatten out' the bumped layer 
####### they can make visible the design or inner ring layers for a different look

    if bump != 0:
        pdb.plug_in_bump_map(image,coin,legend,      145,45,bh_3,0,0,0,150,1,0,0)
        pdb.plug_in_bump_map(image,coin,innerring,   145,45,bh_1,0,0,0,ira,1,0,0)
        pdb.plug_in_bump_map(image,coin,design,      145,45,bh_2,0,0,0,150,1,0,0)
        pdb.plug_in_bump_map(image,innerring ,design,145,45,bh_2,0,0,0,150,1,0,0)
        pdb.plug_in_bump_map(image,innerring2,design,145,45,bh_2,0,0,0,150,1,0,0)

####### Cleanup and exit.
    #put color back on legend
    pdb.gimp_image_select_item(image,0,legend)
    pdb.gimp_context_set_foreground(fg_1)
    pdb.gimp_edit_fill(legend,0)
    pdb.gimp_selection_none(image)
    #set visibles
    pdb.gimp_item_set_visible(blackleather,True)
    pdb.gimp_item_set_visible(coin,True)
    pdb.gimp_item_set_visible(rim,True)
    pdb.gimp_item_set_visible(grooves,True)

    pdb.gimp_display_new(image) #swap this with the display new in 1st layer creation when script is completed.
    pdb.gimp_displays_flush()    
    pdb.gimp_context_pop()
    return()    

# This is the plugin registration function
register(
    "BA_Conbagui_Coin",    
    "Script Based On Conbagui's Gold Coin Tutorial    ",   
    "Requirments show at top",
    "animicule@gimpchat.com", 
    "Brian Andersen", 
    "June 17",
    "BA Conbagui's Gold Coin Tutorial...", 
    "RGB*", 
   [
      (PF_IMAGE,    "image",     "Input image             ",None),
      (PF_DRAWABLE, "idrawable", "Input drawable          ",None),
      (PF_DIRNAME,  "vectordir", "Saved Vectors Directory ", " "),
      (PF_COLOR,    "fg_1",      "Pick Main Color         ",(206,187,120)),
      (PF_COLOR,    "fg_2",      "Pick Rim Color          ",(138,124, 76)),
      (PF_TOGGLE,   "edg",       "Make Rim Grooves?       ", 0),
      (PF_FONT,     "font_t",    "Top Legend Font         ", "Sans"),
      (PF_INT,      "fs_t",      "Top Legend Font Size    ", 120),
      (PF_INT,      "ex_t",      "Extra Spacing Top Font  ", 5),
      (PF_STRING,   "text_t",    "Top Legend Text         ", "CONBAGUI"),
      (PF_FONT,     "font_b",    "Bottom Font             ", "Sans"),
      (PF_INT,      "fs_b",      "Bottom Font Size        ", 80),
      (PF_INT,      "ex_b",      "Extra Spacing Bottom    ", 3),
      (PF_STRING,   "text_b",    "Top Legend Text         ", "THANKS FOR THE TUTORIALS"),
      (PF_BOOL,     "bump",      "Bump Map                ", False),
      (PF_INT,      "bh_1",      "Bump Height Rim         ", 40),
      (PF_INT,      "bh_2",      "Bump Height Stars       ", 40),
      (PF_INT,      "bh_3",      "Bump Height Legend      ", 40),
      (PF_INT,      "ira",       "Bump Ambient InnerRing  ",150),
      (PF_BOOL,     "guides",    "Show Guides             ", True),            
    ], 
    [],
    BA_Conbagui_Coin,
    menu="<Image>/Brian/",
    )

main()
